"""
Supporting functionality for dtddoc.

$Id: docutil.py,v 1.3 2000/01/06 14:03:53 larsga Exp $
"""

# --- Utility functions

# elem_ref_fun must have the signature elem_ref_fun(name,modifier)

def print_cm(out,cm,elem_ref_fun):
    if cm==None:
        out.write("ANY")
        return
    elif cm[1]==[]:
        out.write("EMPTY")
        return
        
    (sep,cont,mod)=cm
    out.write("(")
    for item in cont[:-1]:
        if len(item)==2:
            out.write("%s %s " % (elem_ref_fun(item[0],item[1]),sep))
        else:
            print_cm(out,item,elem_ref_fun)
            out.write(sep+" ")

    item=cont[-1]
    if len(item)==2:
        out.write(elem_ref_fun(item[0],item[1]))
    else:
        print_cm(out,item,elem_ref_fun) 
        out.write(sep+" ")
            
    out.write(")%s " % mod)
